/* DChub - a Direct Connect Hub for Linux
 * Copyright (C) 2001 Eric Prevoteau
 *
 * manage_cnx.h: Copyright (C) Eric Prevoteau <www@ac2i.tzo.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __MANAGE_CNX_H__
#define __MANAGE_CNX_H__

#include "cnx_lst.h"

/*********************************************/
/* this function performs input/output tasks */
/*************************************************************************/
/* input: ptr= entry to manage                                           */
/*        no_read_wait= ==0: wait until something comes from remote side */
/*                      ==1: only send local data and return immediately */
/*        no_send_retry= Only have a real meaning when no_read_wait==1   */
/*                       ==0: the command won't return until all queued  */
/*                            commands to send have not been sent.       */
/*                       ==1: make 1 try to send the queued commands and */
/*                            return even if data was not sent.          */
/*************************************************************************/
/* output: =0: ok     */
/*         !=0: error */
/**********************/
int cnx_io_processing(CNX_ENTRY *ptr, int no_read_wait, int no_send_retry);

/******************************************/
/* main part of the connection management */
/******************************************/
int new_cnx(CNX_ENTRY *ptr);

/**************************************************/
/* this thread handles all the running connection */
/**************************************************/
void *cnxs_fnc(void *dummy);

#endif
